<?php
	/**
		* Plugin Name:       Bubble Menu Pro
		* Plugin URI:        https://codecanyon.net/item/bubble-menu-pro/19659832
		* Description:       Create flyouts bubble menu
		* Version:           2.0
		* Author:            20script
		* Author URI:        https://www.20script.ir
		* License:           GPL-2.0+
		* License URI:       http://www.gnu.org/licenses/gpl-2.0.txt
	*/
	
	require_once dirname(__FILE__) . '/feed.class.php';
	
	if ( ! defined( 'WPINC' ) ) {die;}
	// Declaration Wow-Company class
	if( !class_exists( 'Wow_Company' )) {
		require_once plugin_dir_path( __FILE__ ) . 'asset/class-wow-company.php';				
	}	
	if( !class_exists( 'WOW_DATA' )) {
		require_once plugin_dir_path( __FILE__ ) . 'include/class/data.php';
	}
	if( !class_exists( 'JavaScriptPacker' )) {
		require_once plugin_dir_path( __FILE__ ) . 'include/class/packer.php';
	}
	
	if( !class_exists( 'Wow_Company_Plugin_Update' )) {
		require_once plugin_dir_path( __FILE__ ) . 'include/class-plugin-update.php';
	}
	
	// Uninstall plugin
	register_uninstall_hook( __FILE__, array( 'Bubble_Menu_Pro_Class', 'uninstall' ) );
	// Declaration of the plugin class
	if( !class_exists( 'Bubble_Menu_Pro_Class' ) ) {
		class Bubble_Menu_Pro_Class
		{	
			const PREF = 'bmp';
			public static function uninstall() {
				delete_option( 'wow_license_key_'.self::PREF );
				delete_option( 'wow_license_status_'.self::PREF );
				global $wpdb;
				$wpdb->query( "DROP TABLE IF EXISTS {$wpdb->prefix}wow_".self::PREF );
			}
			function __construct() {
				$this->name = 'Bubble Menu Pro';
				$this->version = '2.0';				
				$this->pluginname = dirname(plugin_basename(__FILE__));
				$this->plugindir = plugin_dir_path( __FILE__ );
				$this->pluginurl = plugin_dir_url( __FILE__ );	
				$this->shortcode = 'Bubble-Menu-Pro';
				
				$plugin_param = array(
				'plugin_name'   => 'Bubble Menu Pro',
				'plugin_folder' => dirname(plugin_basename(__FILE__)),
				'plugin_file'   => basename(__FILE__),
				'plugin_author' => 'Wow-Company',
				);
			
				$plugin_update = new Wow_Company_Plugin_Update($plugin_param);
				
				
				// activate & diactivate
				register_activation_hook( __FILE__, array($this, 'plugin_activate' ) );
				register_deactivation_hook( __FILE__, array($this, 'plugin_deactivate') );				
				// admin pages
				add_action( 'admin_menu', array($this, 'add_menu_page') );
				// show on front end
				add_shortcode('Bubble-Menu-Pro', array($this, 'shortcode') );
				add_action( 'wp_footer', array($this, 'display') );
				// icons in menu
				
				add_filter( 'nav_menu_css_class', array($this, 'nav_menu_css_class') );
				
				add_filter( 'walker_nav_menu_start_el', array($this, 'walker_nav_menu_start_el'), 10, 4 );
				
				add_action( 'wp_enqueue_scripts', array($this, 'scripts_styles' ) );
				
				
				// admin links
				add_filter( 'plugin_row_meta', array($this, 'row_meta'), 10, 4 );
				add_filter( 'plugin_action_links', array($this, 'action_links'), 10, 2 );	
				// check asset folder
				add_filter( 'admin_init', array($this, 'asset_folder') );
				
			}
			// Activate & diactivate
			function plugin_activate() {
				require_once plugin_dir_path( __FILE__ ) . 'include/activator.php';	
			}
			function plugin_deactivate() {	
				require_once plugin_dir_path( __FILE__ ) . 'include/deactivator.php';
			}
			// AdminPanel
			function add_menu_page() {
				add_submenu_page('wow-company', $this->name, $this->name, 'manage_options', $this->pluginname, array( $this, 'plugin_admin' ));
			}
			function plugin_admin() {
				require_once plugin_dir_path( __FILE__ ) . 'admin/index.php';			
			}		
			// Show on Front end
			function scripts_styles(){
				wp_enqueue_style( $this->pluginname.'-font-awesome', $this->pluginurl . 'asset/font-awesome/css/font-awesome.min.css', array(), '4.7.0' );
			}
			
			function shortcode($atts) {
				require plugin_dir_path( __FILE__ ) . 'public/shortcode.php';
			}
			function display() {
				require plugin_dir_path( __FILE__ ) . 'public/display.php';
			}
			// Icons in menu
			
			function nav_menu_css_class( $classes ){
				if( is_array( $classes ) ){
					$tmp_classes = preg_grep( '/^(fa)(-\S+)?$/i', $classes );
					if( !empty( $tmp_classes ) ){
						$classes = array_values( array_diff( $classes, $tmp_classes ) );
					}
				}
				return $classes;
			}
			
			
			function walker_nav_menu_start_el( $item_output, $item, $depth, $args ){
				if( is_array( $item->classes ) ){
					$classes = preg_grep( '/^(fa)(-\S+)?$/i', $item->classes );
					if( !empty( $classes ) ){
						$item_output = self::replace_item( $item_output, $classes );
					}
				}
				return $item_output;
			}
			
			function replace_item( $item_output, $classes ){
				
				
				if( !in_array( 'fa', $classes ) ){
					array_unshift( $classes, 'fa' );
				}
				
				$before = true;
				if( in_array( 'fa-after', $classes ) ){
					$classes = array_values( array_diff( $classes, array( 'fa-after' ) ) );
					$before = false;
				}
				
				$icon = '<i class="' . implode( ' ', $classes ) . ' "></i>';
				
				preg_match( '/(<a.+>)(.+)(<\/a>)/i', $item_output, $matches );
				if( 4 === count( $matches ) ){
					$item_output = $matches[1];
					if( $before ){
						$item_output .= $icon . ' <span class="wow-bmp-text">'  . $matches[2] . '</span>';
						} else {
						$item_output .= '<span class="wow-bmp-text">' . $matches[2] . '</span> ' . $icon;
					}
					$item_output .= $matches[3];
				}
				return $item_output;
			}
			
			// Admin links
			function row_meta( $meta, $plugin_file ){
				if( false === strpos( $plugin_file, basename(__FILE__) ) )
				return $meta;
				$meta[] = '<a href="https://www.facebook.com/wowaffect/" target="_blank">Join us on Facebook</a>';
				return $meta;
			}
			function action_links( $actions, $plugin_file ){
				if( false === strpos( $plugin_file, basename(__FILE__) ) )
				return $actions;
				$settings_link = '<a href="admin.php?page='. $this->pluginname .'">Settings</a>'; 
				array_unshift( $actions, $settings_link ); 
				return $actions; 
			}
			
			// check asset folder
			function asset_folder(){
				$path = plugin_dir_path( __FILE__ ).'asset';
				if (!is_writable($path)) {
					echo "<div class='error' id='message'><p>Please set the 775 access rights (chmod 775) for the '".$path."</p> </div>";
				} 
			}
			
			
		}
		$plugin = new Bubble_Menu_Pro_Class();		
	}				