<?php if ( ! defined( 'ABSPATH' ) ) exit;
	
	add_action( 'wp_enqueue_scripts', 'wow_scripts_styles_bmp' );
	
	function wow_scripts_styles_bmp() {
		wp_enqueue_style( WOW_BMP_BASENAME.'-font-awesome', WOW_BMP_URL . 'asset/font-awesome/css/font-awesome.min.css', array(), '4.7.0' );
	}
		
	//* shortcode
	add_shortcode('Bubble-Menu-Pro', 'wow_shortcode_bmp');
	function wow_shortcode_bmp($atts) {
		extract(shortcode_atts(array('id' => ""), $atts));		
		global $wpdb;
		$table = $wpdb->prefix . "wow_bmp";    
		$sSQL = $wpdb->prepare("select * from $table WHERE id = %d", $id);
		$arrresult = $wpdb->get_results($sSQL); 	
		if (count($arrresult) > 0) {
			foreach ($arrresult as $key => $val) {
				$param = unserialize($val->param);
				if (!empty($param['include_mobile'])){
					$bmp_class = ' bmp-mobile-'.$val->id;
					if (empty($param['screen'])){
						$mobile_screen = '480';
					}
					else {
						$mobile_screen = $param['screen'];
					}
					$mobile_style = '<style>
						@media only screen and (max-width: '.$mobile_screen.'px){
							.bmp-mobile-'.$val->id.' {
								display:none;
							}
						}
					</style>';
				}
				else {
					$bmp_class = '';
					$mobile_style = '';
				}
				ob_start();
				include( 'partials/public.php' );
				$menu = ob_get_contents();
				ob_end_clean();
				
				if ($param['item_user'] == 1) {
					$user = true;
				}
				if ($param['item_user'] == 2) {
					$user = is_user_logged_in();
				}
				if ($param['item_user'] == 3) {
					$user = !is_user_logged_in();
				}
				if (!empty($param['depending_language'])) {
					$item_lang = $param['lang'];
					$site_lang = get_locale();				
					if (substr($site_lang, 0, 2) == $item_lang) {
						$lang = true;
					}
					else {
						$lang = false;
					}
				}
				else if (empty($param['depending_language'])){
					$lang = true;
				}				
				
				if ($user == true && $lang == true ) {
					echo $menu;					
					wp_enqueue_style( WOW_BMP_BASENAME.'-style', plugin_dir_url( __FILE__ ). 'css/style.css', null, WOW_BMP_VERSION);	
					echo $mobile_style;
					
				}
			}
			
			} else {		
			echo "<p><strong>No Records</strong></p>";        
		}  
		
		return ;
	}
	
	//* Include on page and posts
	add_action( 'wp_footer', 'wow_display_bmp' );
	function wow_display_bmp() {
		global $wpdb;    
		$table = $wpdb->prefix . "wow_bmp";   
		$arrresult = $wpdb->get_results("SELECT * FROM " . $table . " order by id asc");
		if (count($arrresult) > 0) {		
			foreach ($arrresult as $key => $val) {
				$param = unserialize($val->param);			
				if ($param['show'] == 'all'){
					echo do_shortcode('[Bubble-Menu-Pro id='.$val->id.']');
				}
				if ($param['show'] == 'onlypost'){
					if( is_single() ){
						echo do_shortcode('[Bubble-Menu-Pro id='.$val->id.']');
					}
				}
				if ($param['show'] == 'onlypage'){
					if( is_page() ){
						echo do_shortcode('[Bubble-Menu-Pro id='.$val->id.']');
					}
				}
				if ($param['show'] == 'posts'){
					if( is_single(preg_split ("/[,]+/", $param['id_post'])) ){
						echo do_shortcode('[Bubble-Menu-Pro id='.$val->id.']');
					}
				}
				if ($param['show'] == 'postsincat'){				
					if( in_category(preg_split ("/[,]+/", $param['id_post'])) ){
						echo do_shortcode('[Bubble-Menu-Pro id='.$val->id.']');						
					}								
				}
				if ($param['show'] == 'pages'){
					if( is_page(preg_split ("/[,]+/", $param['id_post'])) ){
						echo do_shortcode('[Bubble-Menu-Pro id='.$val->id.']');
					}
				}
				if ($param['show'] == 'expost'){
					if( !is_single(preg_split ("/[,]+/", $param['id_post'])) ){
						echo do_shortcode('[Bubble-Menu-Pro id='.$val->id.']');
					}
				}
				if ($param['show'] == 'expage'){
					if( !is_page(preg_split ("/[,]+/", $param['id_post'])) ){
						echo do_shortcode('[Bubble-Menu-Pro id='.$val->id.']');
					}
				}
				
				
			}
		}
	}
	
	
	add_filter( 'nav_menu_css_class', 'wow_nav_menu_css_class_bmp');
	function wow_nav_menu_css_class_bmp( $classes ){
        if( is_array( $classes ) ){
            $tmp_classes = preg_grep( '/^(fa)(-\S+)?$/i', $classes );
            if( !empty( $tmp_classes ) ){
                $classes = array_values( array_diff( $classes, $tmp_classes ) );
			}
		}
        return $classes;
	}
	
	add_filter( 'walker_nav_menu_start_el', 'wow_walker_nav_menu_start_el_bmp', 10, 4 );
	
	function wow_walker_nav_menu_start_el_bmp( $item_output, $item, $depth, $args ){
        if( is_array( $item->classes ) ){
            $classes = preg_grep( '/^(fa)(-\S+)?$/i', $item->classes );
            if( !empty( $classes ) ){
                $item_output = wow_replace_item_bmp( $item_output, $classes );
			}
		}
        return $item_output;
	}
	
	function wow_replace_item_bmp( $item_output, $classes ){
        
		
        if( !in_array( 'fa', $classes ) ){
            array_unshift( $classes, 'fa' );
		}
		
        $before = true;
        if( in_array( 'fa-after', $classes ) ){
            $classes = array_values( array_diff( $classes, array( 'fa-after' ) ) );
            $before = false;
		}
		
        $icon = '<i class="' . implode( ' ', $classes ) . ' "></i>';
		
        preg_match( '/(<a.+>)(.+)(<\/a>)/i', $item_output, $matches );
        if( 4 === count( $matches ) ){
            $item_output = $matches[1];
            if( $before ){
                $item_output .= $icon . ' <span class="wow-bmp-text">'  . $matches[2] . '</span>';
				} else {
                $item_output .= '<span class="wow-bmp-text">' . $matches[2] . '</span> ' . $icon;
			}
            $item_output .= $matches[3];
		}
        return $item_output;
	}
	
